/*
 * mFis.c
 *
 * Code generation for model "mFis.mdl".
 *
 * Model version              : 1.5
 * Simulink Coder version : 8.0 (R2011a) 09-Mar-2011
 * C source code generated on : Tue Dec 10 15:01:54 2013
 *
 * Target selection: grt.tlc
 * Note: GRT includes extra infrastructure and instrumentation for prototyping
 * Embedded hardware selection: 32-bit Generic
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "mFis.h"
#include "mFis_private.h"

/* Block signals (auto storage) */
BlockIO_mFis mFis_B;

/* Block states (auto storage) */
D_Work_mFis mFis_DWork;

/* Real-time model */
RT_MODEL_mFis mFis_M_;
RT_MODEL_mFis *const mFis_M = &mFis_M_;
static void rate_monotonic_scheduler(void);
time_T rt_SimUpdateDiscreteEvents(
  int_T rtmNumSampTimes, void *rtmTimingData, int_T *rtmSampleHitPtr, int_T
  *rtmPerTaskSampleHits )
{
  rtmSampleHitPtr[1] = rtmStepTask(mFis_M, 1);
  UNUSED_PARAMETER(rtmNumSampTimes);
  UNUSED_PARAMETER(rtmTimingData);
  UNUSED_PARAMETER(rtmPerTaskSampleHits);
  return(-1);
}

/* rate_monotonic_scheduler */
static void rate_monotonic_scheduler(void)
{
  /* Compute which subrates run during the next base time step.  Subrates
   * are an integer multiple of the base rate counter.  Therefore, the subtask
   * counter is reset when it reaches its limit (zero means run).
   */
  (mFis_M->Timing.TaskCounters.TID[1])++;
  if ((mFis_M->Timing.TaskCounters.TID[1]) > 1) {/* Sample time: [2.0s, 0.0s] */
    mFis_M->Timing.TaskCounters.TID[1] = 0;
  }
}

/* Model output function for TID0 */
static void mFis_output0(int_T tid)    /* Sample time: [1.0s, 0.0s] */
{
  {                                    /* Sample time: [1.0s, 0.0s] */
    rate_monotonic_scheduler();
  }

  /* tid is required for a uniform function interface.
   * Argument tid is not used in the function. */
  UNUSED_PARAMETER(tid);
}

/* Model update function for TID0 */
static void mFis_update0(int_T tid)    /* Sample time: [1.0s, 0.0s] */
{
  /* Update absolute time */
  /* The "clockTick0" counts the number of times the code of this task has
   * been executed. The absolute time is the multiplication of "clockTick0"
   * and "Timing.stepSize0". Size of "clockTick0" ensures timer will not
   * overflow during the application lifespan selected.
   * Timer of this task consists of two 32 bit unsigned integers.
   * The two integers represent the low bits Timing.clockTick0 and the high bits
   * Timing.clockTickH0. When the low bit overflows to 0, the high bits increment.
   */
  if (!(++mFis_M->Timing.clockTick0)) {
    ++mFis_M->Timing.clockTickH0;
  }

  mFis_M->Timing.t[0] = mFis_M->Timing.clockTick0 * mFis_M->Timing.stepSize0 +
    mFis_M->Timing.clockTickH0 * mFis_M->Timing.stepSize0 * 4294967296.0;

  /* tid is required for a uniform function interface.
   * Argument tid is not used in the function. */
  UNUSED_PARAMETER(tid);
}

/* Model output function for TID1 */
static void mFis_output1(int_T tid)    /* Sample time: [2.0s, 0.0s] */
{
  /* local block i/o variables */
  real_T rtb_Sum1;
  real_T rtb_TmpSignalConversionAtToWork[3];
  real_T rtb_Weighting;
  real_T rtb_Weighting_j;
  real_T rtb_Weighting_m;
  real_T rtb_Weighting_d;
  real_T rtb_Switch;
  real_T rtb_Merge;
  real_T rtb_ProductCOA[101];
  real_T rtb_Sum;
  int32_T i;
  real_T minV;
  real_T minV_0;
  real_T minV_1;

  /* UnitDelay: '<Root>/Unit Delay' */
  mFis_B.UnitDelay = mFis_DWork.UnitDelay_DSTATE;

  /* Product: '<S14>/Product (gaussmf)' incorporates:
   *  Constant: '<S14>/mu'
   *  Constant: '<S14>/sigma'
   *  Sum: '<S14>/Sum'
   */
  rtb_Weighting = (mFis_B.UnitDelay - mFis_P.mu_Value) / mFis_P.sigma_Value;

  /* Product: '<S5>/Weighting' incorporates:
   *  Constant: '<S5>/Weight'
   *  Gain: '<S14>/Gain'
   *  Math: '<S14>/Exponential (gaussmf)'
   *  Math: '<S14>/Squaring (gaussmf)'
   *
   * About '<S14>/Exponential (gaussmf)':
   *  Operator: exp
   */
  rtb_Weighting = exp(rtb_Weighting * rtb_Weighting * mFis_P.Gain_Gain) *
    mFis_P.Weight_Value;

  /* Product: '<S15>/Product (gaussmf)' incorporates:
   *  Constant: '<S15>/mu'
   *  Constant: '<S15>/sigma'
   *  Sum: '<S15>/Sum'
   */
  rtb_Weighting_j = (mFis_B.UnitDelay - mFis_P.mu_Value_p) /
    mFis_P.sigma_Value_g;

  /* Product: '<S6>/Weighting' incorporates:
   *  Constant: '<S6>/Weight'
   *  Gain: '<S15>/Gain'
   *  Math: '<S15>/Exponential (gaussmf)'
   *  Math: '<S15>/Squaring (gaussmf)'
   *
   * About '<S15>/Exponential (gaussmf)':
   *  Operator: exp
   */
  rtb_Weighting_j = exp(rtb_Weighting_j * rtb_Weighting_j * mFis_P.Gain_Gain_g) *
    mFis_P.Weight_Value_m;

  /* Product: '<S16>/Product (gaussmf)' incorporates:
   *  Constant: '<S16>/mu'
   *  Constant: '<S16>/sigma'
   *  Sum: '<S16>/Sum'
   */
  rtb_Weighting_m = (mFis_B.UnitDelay - mFis_P.mu_Value_o) /
    mFis_P.sigma_Value_d;

  /* Product: '<S7>/Weighting' incorporates:
   *  Constant: '<S7>/Weight'
   *  Gain: '<S16>/Gain'
   *  Math: '<S16>/Exponential (gaussmf)'
   *  Math: '<S16>/Squaring (gaussmf)'
   *
   * About '<S16>/Exponential (gaussmf)':
   *  Operator: exp
   */
  rtb_Weighting_m = exp(rtb_Weighting_m * rtb_Weighting_m * mFis_P.Gain_Gain_p) *
    mFis_P.Weight_Value_h;

  /* Product: '<S17>/Product (gaussmf)' incorporates:
   *  Constant: '<S17>/mu'
   *  Constant: '<S17>/sigma'
   *  Sum: '<S17>/Sum'
   */
  rtb_Weighting_d = (mFis_B.UnitDelay - mFis_P.mu_Value_e) /
    mFis_P.sigma_Value_d3;

  /* Product: '<S8>/Weighting' incorporates:
   *  Constant: '<S8>/Weight'
   *  Gain: '<S17>/Gain'
   *  Math: '<S17>/Exponential (gaussmf)'
   *  Math: '<S17>/Squaring (gaussmf)'
   *
   * About '<S17>/Exponential (gaussmf)':
   *  Operator: exp
   */
  rtb_Weighting_d = exp(rtb_Weighting_d * rtb_Weighting_d * mFis_P.Gain_Gain_d) *
    mFis_P.Weight_Value_h4;

  /* Product: '<S18>/Product (gaussmf)' incorporates:
   *  Constant: '<S18>/mu'
   *  Constant: '<S18>/sigma'
   *  Sum: '<S18>/Sum'
   */
  rtb_Switch = (mFis_B.UnitDelay - mFis_P.mu_Value_c) / mFis_P.sigma_Value_m;

  /* Product: '<S9>/Weighting' incorporates:
   *  Constant: '<S9>/Weight'
   *  Gain: '<S18>/Gain'
   *  Math: '<S18>/Exponential (gaussmf)'
   *  Math: '<S18>/Squaring (gaussmf)'
   *
   * About '<S18>/Exponential (gaussmf)':
   *  Operator: exp
   */
  rtb_Switch = exp(rtb_Switch * rtb_Switch * mFis_P.Gain_Gain_b) *
    mFis_P.Weight_Value_m4;
  for (i = 0; i < 101; i++) {
    /* MinMax: '<S5>/impMethod' incorporates:
     *  Constant: '<S11>/mf5'
     */
    rtb_Sum = (rtb_Weighting <= mFis_P.mf5_Value[i]) || rtIsNaN
      (mFis_P.mf5_Value[i]) ? rtb_Weighting : mFis_P.mf5_Value[i];

    /* MinMax: '<S6>/impMethod' incorporates:
     *  Constant: '<S11>/mf4'
     */
    rtb_Merge = (rtb_Weighting_j <= mFis_P.mf4_Value[i]) || rtIsNaN
      (mFis_P.mf4_Value[i]) ? rtb_Weighting_j : mFis_P.mf4_Value[i];

    /* MinMax: '<S7>/impMethod' incorporates:
     *  Constant: '<S11>/mf3'
     */
    minV_1 = (rtb_Weighting_m <= mFis_P.mf3_Value[i]) || rtIsNaN
      (mFis_P.mf3_Value[i]) ? rtb_Weighting_m : mFis_P.mf3_Value[i];

    /* MinMax: '<S8>/impMethod' incorporates:
     *  Constant: '<S11>/mf2'
     */
    minV_0 = (rtb_Weighting_d <= mFis_P.mf2_Value[i]) || rtIsNaN
      (mFis_P.mf2_Value[i]) ? rtb_Weighting_d : mFis_P.mf2_Value[i];

    /* MinMax: '<S9>/impMethod' incorporates:
     *  Constant: '<S11>/mf1'
     */
    minV = (rtb_Switch <= mFis_P.mf1_Value[i]) || rtIsNaN(mFis_P.mf1_Value[i]) ?
      rtb_Switch : mFis_P.mf1_Value[i];

    /* MinMax: '<S3>/AggMethod1' */
    rtb_Sum = (rtb_Sum >= rtb_Merge) || rtIsNaN(rtb_Merge) ? rtb_Sum : rtb_Merge;
    rtb_Sum = (rtb_Sum >= minV_1) || rtIsNaN(minV_1) ? rtb_Sum : minV_1;
    rtb_Sum = (rtb_Sum >= minV_0) || rtIsNaN(minV_0) ? rtb_Sum : minV_0;
    rtb_Sum = (rtb_Sum >= minV) || rtIsNaN(minV) ? rtb_Sum : minV;
    rtb_ProductCOA[i] = rtb_Sum;
  }

  /* Sum: '<S4>/Sum1' incorporates:
   *  MinMax: '<S3>/AggMethod1'
   *  Sum: '<S4>/Sum'
   */
  rtb_Merge = rtb_ProductCOA[0];
  for (i = 0; i < 100; i++) {
    rtb_Merge += rtb_ProductCOA[i + 1];
  }

  rtb_Sum1 = rtb_Merge;

  /* End of Sum: '<S4>/Sum1' */

  /* If: '<S4>/If' incorporates:
   *  Constant: '<S12>/One'
   *  Inport: '<S13>/u1'
   */
  if (rtb_Sum1 <= 0.0) {
    /* Outputs for IfAction SubSystem: '<S4>/Action: One' incorporates:
     *  ActionPort: '<S12>/Action Port'
     */
    rtb_Merge = mFis_P.One_Value;

    /* End of Outputs for SubSystem: '<S4>/Action: One' */
  } else {
    /* Outputs for IfAction SubSystem: '<S4>/Action: u1' incorporates:
     *  ActionPort: '<S13>/Action Port'
     */
    rtb_Merge = rtb_Sum1;

    /* End of Outputs for SubSystem: '<S4>/Action: u1' */
  }

  /* End of If: '<S4>/If' */

  /* Switch: '<S3>/Switch' incorporates:
   *  Constant: '<S3>/MidRange'
   *  Constant: '<S3>/Zero'
   *  Product: '<S4>/Averaging (COA)'
   *  RelationalOperator: '<S3>/Zero Firing Strength?'
   *  Sum: '<S3>/Total Firing Strength'
   */
  if ((real_T)((((rtb_Weighting + rtb_Weighting_j) + rtb_Weighting_m) +
                rtb_Weighting_d) + rtb_Switch > mFis_P.Zero_Value) >=
      mFis_P.Switch_Threshold) {
    /* Product: '<S4>/Product (COA)' incorporates:
     *  Constant: '<S4>/x data'
     *  MinMax: '<S3>/AggMethod1'
     */
    for (i = 0; i < 101; i++) {
      rtb_ProductCOA[i] *= mFis_P.xdata_Value[i];
    }

    /* End of Product: '<S4>/Product (COA)' */

    /* Sum: '<S4>/Sum' incorporates:
     *  Sum: '<S4>/Sum1'
     */
    rtb_Sum = rtb_ProductCOA[0];
    for (i = 0; i < 100; i++) {
      rtb_Sum += rtb_ProductCOA[i + 1];
    }

    /* End of Sum: '<S4>/Sum' */
    rtb_Switch = rtb_Sum / rtb_Merge;
  } else {
    rtb_Switch = mFis_P.MidRange_Value;
  }

  /* End of Switch: '<S3>/Switch' */

  /* Sum: '<Root>/Sum' incorporates:
   *  Gain: '<Root>/Gain'
   */
  mFis_B.Sum = mFis_P.Gain_Gain_c * mFis_B.UnitDelay + rtb_Switch;

  /* SignalConversion: '<Root>/TmpSignal ConversionAtTo WorkspaceInport1' */
  rtb_TmpSignalConversionAtToWork[0] = mFis_B.UnitDelay;
  rtb_TmpSignalConversionAtToWork[1] = mFis_B.Sum;
  rtb_TmpSignalConversionAtToWork[2] = rtb_Switch;

  /* ToWorkspace: '<Root>/To Workspace' */
  rt_UpdateStructLogVar((StructLogVar *)mFis_DWork.ToWorkspace_PWORK.LoggedData,
                        (NULL), rtb_TmpSignalConversionAtToWork);

  /* tid is required for a uniform function interface.
   * Argument tid is not used in the function. */
  UNUSED_PARAMETER(tid);
}

/* Model update function for TID1 */
static void mFis_update1(int_T tid)    /* Sample time: [2.0s, 0.0s] */
{
  /* Update for UnitDelay: '<Root>/Unit Delay' */
  mFis_DWork.UnitDelay_DSTATE = mFis_B.Sum;

  /* Update absolute time */
  /* The "clockTick1" counts the number of times the code of this task has
   * been executed. The absolute time is the multiplication of "clockTick1"
   * and "Timing.stepSize1". Size of "clockTick1" ensures timer will not
   * overflow during the application lifespan selected.
   * Timer of this task consists of two 32 bit unsigned integers.
   * The two integers represent the low bits Timing.clockTick1 and the high bits
   * Timing.clockTickH1. When the low bit overflows to 0, the high bits increment.
   */
  if (!(++mFis_M->Timing.clockTick1)) {
    ++mFis_M->Timing.clockTickH1;
  }

  mFis_M->Timing.t[1] = mFis_M->Timing.clockTick1 * mFis_M->Timing.stepSize1 +
    mFis_M->Timing.clockTickH1 * mFis_M->Timing.stepSize1 * 4294967296.0;

  /* tid is required for a uniform function interface.
   * Argument tid is not used in the function. */
  UNUSED_PARAMETER(tid);
}

static void mFis_output(int_T tid)
{
  switch (tid) {
   case 0 :
    mFis_output0(0);
    break;

   case 1 :
    mFis_output1(1);
    break;

   default :
    break;
  }
}

static void mFis_update(int_T tid)
{
  switch (tid) {
   case 0 :
    mFis_update0(0);
    break;

   case 1 :
    mFis_update1(1);
    break;

   default :
    break;
  }
}

/* Model initialize function */
void mFis_initialize(boolean_T firstTime)
{
  (void)firstTime;

  /* Registration code */

  /* initialize non-finites */
  rt_InitInfAndNaN(sizeof(real_T));

  /* initialize real-time model */
  (void) memset((void *)mFis_M, 0,
                sizeof(RT_MODEL_mFis));

  /* Initialize timing info */
  {
    int_T *mdlTsMap = mFis_M->Timing.sampleTimeTaskIDArray;
    mdlTsMap[0] = 0;
    mdlTsMap[1] = 1;
    mFis_M->Timing.sampleTimeTaskIDPtr = (&mdlTsMap[0]);
    mFis_M->Timing.sampleTimes = (&mFis_M->Timing.sampleTimesArray[0]);
    mFis_M->Timing.offsetTimes = (&mFis_M->Timing.offsetTimesArray[0]);

    /* task periods */
    mFis_M->Timing.sampleTimes[0] = (1.0);
    mFis_M->Timing.sampleTimes[1] = (2.0);

    /* task offsets */
    mFis_M->Timing.offsetTimes[0] = (0.0);
    mFis_M->Timing.offsetTimes[1] = (0.0);
  }

  rtmSetTPtr(mFis_M, &mFis_M->Timing.tArray[0]);

  {
    int_T *mdlSampleHits = mFis_M->Timing.sampleHitArray;
    int_T *mdlPerTaskSampleHits = mFis_M->Timing.perTaskSampleHitsArray;
    mFis_M->Timing.perTaskSampleHits = (&mdlPerTaskSampleHits[0]);
    mdlSampleHits[0] = 1;
    mFis_M->Timing.sampleHits = (&mdlSampleHits[0]);
  }

  rtmSetTFinal(mFis_M, 3.0);
  mFis_M->Timing.stepSize0 = 1.0;
  mFis_M->Timing.stepSize1 = 2.0;

  /* Setup for data logging */
  {
    static RTWLogInfo rt_DataLoggingInfo;
    mFis_M->rtwLogInfo = &rt_DataLoggingInfo;
  }

  /* Setup for data logging */
  {
    rtliSetLogXSignalInfo(mFis_M->rtwLogInfo, (NULL));
    rtliSetLogXSignalPtrs(mFis_M->rtwLogInfo, (NULL));
    rtliSetLogT(mFis_M->rtwLogInfo, "tout");
    rtliSetLogX(mFis_M->rtwLogInfo, "");
    rtliSetLogXFinal(mFis_M->rtwLogInfo, "");
    rtliSetSigLog(mFis_M->rtwLogInfo, "");
    rtliSetLogVarNameModifier(mFis_M->rtwLogInfo, "rt_");
    rtliSetLogFormat(mFis_M->rtwLogInfo, 0);
    rtliSetLogMaxRows(mFis_M->rtwLogInfo, 1000);
    rtliSetLogDecimation(mFis_M->rtwLogInfo, 1);
    rtliSetLogY(mFis_M->rtwLogInfo, "");
    rtliSetLogYSignalInfo(mFis_M->rtwLogInfo, (NULL));
    rtliSetLogYSignalPtrs(mFis_M->rtwLogInfo, (NULL));
  }

  mFis_M->solverInfoPtr = (&mFis_M->solverInfo);
  mFis_M->Timing.stepSize = (1.0);
  rtsiSetFixedStepSize(&mFis_M->solverInfo, 1.0);
  rtsiSetSolverMode(&mFis_M->solverInfo, SOLVER_MODE_MULTITASKING);

  /* block I/O */
  mFis_M->ModelData.blockIO = ((void *) &mFis_B);
  (void) memset(((void *) &mFis_B), 0,
                sizeof(BlockIO_mFis));

  /* parameters */
  mFis_M->ModelData.defaultParam = ((real_T *)&mFis_P);

  /* states (dwork) */
  mFis_M->Work.dwork = ((void *) &mFis_DWork);
  (void) memset((void *)&mFis_DWork, 0,
                sizeof(D_Work_mFis));
}

/* Model terminate function */
void mFis_terminate(void)
{
}

/*========================================================================*
 * Start of GRT compatible call interface                                 *
 *========================================================================*/
void MdlOutputs(int_T tid)
{
  mFis_output(tid);
}

void MdlUpdate(int_T tid)
{
  mFis_update(tid);
}

void MdlInitializeSizes(void)
{
  mFis_M->Sizes.numContStates = (0);   /* Number of continuous states */
  mFis_M->Sizes.numY = (0);            /* Number of model outputs */
  mFis_M->Sizes.numU = (0);            /* Number of model inputs */
  mFis_M->Sizes.sysDirFeedThru = (0);  /* The model is not direct feedthrough */
  mFis_M->Sizes.numSampTimes = (2);    /* Number of sample times */
  mFis_M->Sizes.numBlocks = (81);      /* Number of blocks */
  mFis_M->Sizes.numBlockIO = (2);      /* Number of block outputs */
  mFis_M->Sizes.numBlockPrms = (633);  /* Sum of parameter "widths" */
}

void MdlInitializeSampleTimes(void)
{
}

void MdlInitialize(void)
{
  /* InitializeConditions for UnitDelay: '<Root>/Unit Delay' */
  mFis_DWork.UnitDelay_DSTATE = mFis_P.UnitDelay_X0;
}

void MdlStart(void)
{
  /* Start for ToWorkspace: '<Root>/To Workspace' */
  {
    static int_T rt_ToWksWidths[] = { 3 };

    static int_T rt_ToWksNumDimensions[] = { 1 };

    static int_T rt_ToWksDimensions[] = { 3 };

    static boolean_T rt_ToWksIsVarDims[] = { 0 };

    static int_T *rt_ToWksCurrSigDims[] = { (NULL) };

    static BuiltInDTypeId rt_ToWksDataTypeIds[] = { SS_DOUBLE };

    static int_T rt_ToWksComplexSignals[] = { 0 };

    static int_T rt_ToWksFrameData[] = { 0 };

    static const char_T *rt_ToWksLabels[] = { "" };

    static RTWLogSignalInfo rt_ToWksSignalInfo = {
      1,
      rt_ToWksWidths,
      rt_ToWksNumDimensions,
      rt_ToWksDimensions,
      rt_ToWksIsVarDims,
      rt_ToWksCurrSigDims,
      rt_ToWksDataTypeIds,
      rt_ToWksComplexSignals,
      rt_ToWksFrameData,

      { rt_ToWksLabels },
      (NULL),
      (NULL),
      (NULL),

      { (NULL) },

      { (NULL) },
      (NULL),
      (NULL)
    };

    static const char_T rt_ToWksBlockName[] = "mFis/To Workspace";
    mFis_DWork.ToWorkspace_PWORK.LoggedData = rt_CreateStructLogVar(
      mFis_M->rtwLogInfo,
      0.0,
      rtmGetTFinal(mFis_M),
      mFis_M->Timing.stepSize0,
      (&rtmGetErrorStatus(mFis_M)),
      "simout",
      0,
      0,
      1,
      2.0,
      &rt_ToWksSignalInfo,
      rt_ToWksBlockName);
    if (mFis_DWork.ToWorkspace_PWORK.LoggedData == (NULL))
      return;
  }

  MdlInitialize();
}

void MdlTerminate(void)
{
  mFis_terminate();
}

RT_MODEL_mFis *mFis(void)
{
  mFis_initialize(1);
  return mFis_M;
}

/*========================================================================*
 * End of GRT compatible call interface                                   *
 *========================================================================*/
