clc 
clear all
%% System Paramters
m = 0.5;
M = 2;
l = 0.5;
g = 9.8;
%% Linearized Mathematical Model - Gantry Crane 
A = [0 1 0 0;0 0 m*g/M 0;0 0 0 1;0 0 -((M+m)/(M*l))*g 0];
B = [0;1/M;0;-1/(M*l)];
C = [1 0 0 0;0 0 1 0];
D = [0];
%% Controllability check
poles = eig(A);
wc=ctrb(A,B);
det(wc);
%% LQR code
Q=[10 0 0 0;0 10 0 0;0 0 100 0;0 0 0 10];
R= 0.001;
k=lqr(A,B,Q,R)
%% Plot
P=A-B*k;
Q=B*k(1,1);
%% Responce Plot
t = 0:0.1:10;
y=step(P,Q,C,D,1,t);y1 = [1 0]*y';
y2 = [0 1]*y';
t = 0:0.1:10;
x=step(A,B,C,D,1,t);
x1 = [1 0]*x';
x2 = [0 1]*x';
subplot(4,1,1);plot(t,x1),grid
title('Responce Curves - Payload Movement')
ylabel('Angular Velocity(rad/s)')
xlabel('Time(sec)')
subplot(4,1,3);plot(t,x2),grid
ylabel('Swing(rad)')
xlabel('Time(sec)')
subplot(4,1,4);plot(t,y2),grid
ylabel('Con(rad)')
xlabel('Time(sec)')
subplot(4,1,2);plot(t,y1),grid
ylabel('Con(m)')
xlabel('Time(sec)')